import java.awt.*;
import java.awt.event.*;
import java.awt.Graphics;
import javax.swing.*;

/**Tato trieda je hlavna trieda. Je to applet a sluzi na inicializaciu premennych.**/

public class Hanoj extends JApplet {
	/** pre narast prenosnosti **/
	private static final long serialVersionUID = 2009010901L;
	/** sirka appletu **/
	public int sizeX = 600;
	/** vyska appletu **/
	public int sizeY = 450;
	/** hodnota kodu stlacenej klavesy **/
	public int key;
	/** pocet tehliciek je vlastne uroven hry. Urci kolko tehliciek bude na zaciatku hry **/
	public int pocetTeh = 7;
	/** je to pomocna premenna urovne**/
	public int pomUroven;
	/** premenna na nacitanie obrazka pozadia **/
	public Image Background;
	/** premenna na nacitanie obrazka Cucatka **/
	public Image ObrCucatko;
	/** premenna na nacitanie obrazka Tehlicky **/
	public Image ObrTehlicka;
	/** premenna na nacitanie obrazka Stlpika **/
	public Image ObrStlpik;
	/** premenna na nacitanie obrazka vykrik hura, pri konci hry **/
	public Image Hura;
	/** zistuje ci bolo kliknute myskou **/
	public boolean klik;
	/** pomocna premmenna pre index tehlicky **/
	public int tehI;
	/** stara pozicia x **/
	public int oldStavX;
	/** stara pozicia y **/
	public int oldStavY;
	
	/** premenna pre buttony b1, b2, cize pre start a restart **/
	public JButton b1, b2;
	/** premenna pre button Pauza, s ktorym sa da hra pozastavit a nasledne
	 * znovu spustit **/
	public JButton bPauza;
	/** premenna pre RadioButtony b1, b2, cize pre hranie klavesami alebo hranie myskou **/
	public JRadioButton b3, b4;
	/** premenna pre list, ktory sluzi na vyber urovne hry.**/
	public List theList;		
	
	/** vyborna premenna na odsranenie blikania, nacita sa dany obrazok do pamate..a potom sa
	 * uz len vykresluje **/
	public Image backbuffer;
	/** pouziva sa tiez na odstranie blikania **/
	public Graphics backg;
	/** zisti, ci sa bude hrat myskou **/
	public boolean myska;
	/** zisti, ci sa bude hrat klavesnicou **/
	public boolean klavesnica;
	/** zisti, ci bol stlaceny start **/
	public boolean start;
	/** premenna pre uroven hry..podobna premennej pocet tehliciek **/
	public int level;
	/** Zisti ci je koniec..teda ci niekto presiel hru, ale pouziva sa aj pri pauznuti
	 * hry. Vtedy vlastne hrac nemoze nic robi s tehlickami **/
	public boolean end;
		
	/** tu sa vola trieda Stlpik s danym poctom stpikov**/
	public Stlpik[] stl = new Stlpik[3];
	/** tu sa vola trieda Cucatko **/
	public Cucatko cuc;
	/** tu sa vola trieda Tehlicka s danym poctom tehliciek **/
	public Tehlicka[] teh = new Tehlicka[pocetTeh];	
	
	/** Premenna na vytvorenie a nasladne volanie canvasu **/
	public Hanoj_canvas hc;
	/** Sem sa vypisuje pocet krokov **/
	public JTextField steps;
	/** Tato premenna sa incrementuje priamoumerne s urobenym krokom t.j. polozenie tehlicky **/
	public int step;
	/** JComboBox sluzi na vybratie si urovne hry pomocou vylistovania moznosti **/
	public JComboBox list;
	/** Tento label sluzi na zobrazenie casovaca v hre **/
	public Label lab;
	/** Toto je Thread, ktory sa vola casovac a ten sa updatuje kazda sekundu **/
	public Casovac thread;
	/** Premenna go dovoli alebo zakaze casovac pripocitavat sekundy **/
	public boolean go;
	/** Do tejto premennej sa zobrazuje aktualny cas casovaca **/
	public int cas;
	
	/** Toto je init appletu. Tu sa vsetky premenne inicializuju, vytvoria sa obrazky, actionListenery, 
	 * je to zaciatok. **/
		
	public void init() {
		/** nastavi sa layout **/
		setLayout(new BorderLayout());
		/** layout na tuto sirku a vysku **/
		setSize(sizeX, sizeY+20);
		/** vytvori sa canvas **/
		hc = new Hanoj_canvas(this);
		add(hc);		
		
		/** vytvori sa casovac **/
		thread = new Casovac(this);
		/** vytvori sa label s casom 0 **/
		lab = new Label("Time    0");		
		go = false;
		cas = 0;
		/** spusti sa thread casovaca **/
		thread.start();
		
		/** pole s urovnami hier **/
		String[] levelik = { "3", "4", "5", "6", "7" };
		/** vytvori sa JComboBox **/
		list = new JComboBox(levelik);
		/** nastavi sa na najtahsiu uroven, ktora sa nachadza na index 4 a je to siedma. **/
		list.setSelectedIndex(4);		
		/** pocet krokov sa nastavi na 0 **/
		step = 0;
		myska = false;
		klavesnica = true;
		start = false;
		//level = 3;
		level = Integer.valueOf((String)list.getSelectedItem());
		end = false;

		/** vytovir sa panel, kde sa budu spustat tlacitka **/
		Panel lbPanel = new Panel();		
		/** vytvori sa tlacitko start **/
		b1 = new JButton("tart");
		/** vytvori sa tlacitko restart **/
		b2 = new JButton("Retart");
		/** vytvori sa tlacitko pauza **/
		bPauza = new JButton("Pauza");
		/** vytvori sa radioButton pre hru sipkami **/
		b3 = new JRadioButton("pkami");
		/** vytvori sa radioButton pre hru myskou **/
		b4 = new JRadioButton("mykou");
		/**  Zgrupnu sa radioButtony. **/
	    ButtonGroup group = new ButtonGroup();
	    group.add(b3);
	    group.add(b4);
	    
	    /** vytvori sa textove pole,kde sa budu zobrazovat kroky **/
	    steps = new JTextField(" 0 ");	    	    	    	    	    	    	    	   	    	   
	    /** do panelu sa postupne pridaju tlacitka start, restart, pauza, radioButtony
	     * a list **/
		lbPanel.add(b1);
		lbPanel.add(b2);
		lbPanel.add(bPauza);
		lbPanel.add(steps);
		lbPanel.add(lab);
		lbPanel.add(b3);
		lbPanel.add(b4);
		lbPanel.add(list);				
		add("South",lbPanel);
		
		/** Plocha sa resize na danu sirku vysku **/
		resize(sizeX, sizeY+20);		
		/** Nacitaju sa obrazky, ktore sa pouzivaj v gre **/
		Background = getImage(getCodeBase(), "Background.gif");
		ObrTehlicka = getImage(getCodeBase(), "ObrTehlickaGif.gif");
		ObrCucatko = getImage(getCodeBase(), "oblak.gif");		
		ObrStlpik = getImage(getCodeBase(), "ObrStlpik.gif");
		Hura = getImage(getCodeBase(), "hura.gif");
			
		klik = false;					
		
		/** Sluzi na odstranenie blikania z hry **/
		backbuffer = createImage( sizeX-1, sizeY-1 );
	    backg = backbuffer.getGraphics();
	    backg.setColor( Color.white );	    	    			    	   
	    
	    ActionListener al = new ActionListener() {
	    	/** tato metoda je actionListener pre tlacitka start a restart **/
		      public void actionPerformed(ActionEvent e){
		        String name = 		        	
		          ((JButton)e.getSource()).getText();
		        /** Tato cast sluzi na obnovenie povodneho rozlozenia hry **/
		    	if (name == "tart") {		    		
		    		/** tato premenna urcuje ci ma ist casovac **/
		    		go = true;
		    		/** casovacu sa nastavi hodnota casu na -1, bude sa to javit ako na 0,
		    		 * hrac ma tak cas kliknut naspat do plochy **/
		    		cas = -1;
		    		/** pocet tehliciek sa nastavi na hodnotu levelu hry **/
		    		pocetTeh = level;
		    		/** kroky sa vynuluju **/
		    		step = 0;
					steps.setText("     " + String.valueOf(step) + "     ");
					/** zisti sa ci je vybraty radio button **/
		    		if (myska || klavesnica) {
		    		  start = true;
		    		  pocetTeh = level;				    		  
		    		  end = false;
			    		int pom = 100;
			    		/** tu sa nastavi povodne rozlozenie veziciek **/
						for (int i = 0; i < 3; i++) {
							stl[i].x = pom;
							stl[i].y = 300;				
							pom += 200;
						}
						/** tu sa nastavi povodne rozlozenie cucatka **/
						cuc.x = stl[1].x-45;
						cuc.y = 20;
						cuc.cisloVeze = 1;
											
						pom = 405;
						int pom2 = 0;
						/** tu sa nastavi povodne rozlozenie tehliciek **/
						for (int i = 0; i < pocetTeh; i++) {				
							teh[i].x = cuc.x-25-pom2;
							teh[i].y = pom;
							teh[i].width = 150+(2*pom2);
							teh[i].cisloVeze = 1;
							pom -= 15;
							pom2 -= 10;
						}
					  //hc.setVisible(true);
			    	  //hc.setFocusable(true);	
		    		  hc.repaint();
		    		}		    		
		    	}
		    	/** pri restarte sa tiez nastavi povodne rozlozenie veziciek, tehliciek
		    	 * a cucatka. Rozdiel je len v tom, ze restartom nespustime hru 
		    	 * na zaciatku **/
		    	else if (name == "Retart") {
		    		if (start) {
		    		cas = -1;
		    		go = true;
		    		step = 0;
		    		steps.setText("     " + String.valueOf(step) + "     ");
		    		end = false;
		    		int pom = 100;
					for (int i = 0; i < 3; i++) {
						stl[i].x = pom;
						stl[i].y = 300;				
						pom += 200;
					}
								
					cuc.x = stl[1].x-45;
					cuc.y = 20;
					cuc.cisloVeze = 1;
										
					pom = 405;
					int pom2 = 0;
					for (int i = 0; i < pocetTeh; i++) {				
						teh[i].x = cuc.x-25-pom2;
						teh[i].y = pom;
						teh[i].width = 150+(2*pom2);
						teh[i].cisloVeze = 1;
						pom -= 15;
						pom2 -= 10;
					}
					hc.repaint();
		    	}
		    	}
		    	/** Ak je stlacena pauza zastavi sa pocitadlo a prestane sa dat ovladat
		    	 * hra **/
		    	else if (name == "Pauza") {
		    		if (go) {
		    		  go = false;
		    		  end = true;	
		    		  ((JButton)e.getSource()).setText("pokracuj");
		    		  hc.repaint();
		    		}
		    	}
		    	/** ak sa stlaci znovu, hra pokracuje presne tam kde sme prestali **/
		    	else if (name == "pokracuj") {
		    		go = true;
		    		end = false;	
		    		((JButton)e.getSource()).setText("Pauza");
		    		hc.repaint();
		    	}
		      }
		    };
		    /** Teraz sa pridaju k tlacitkami dane listenery **/    
	    b1.addActionListener(al);
	    b2.addActionListener(al);
	    bPauza.addActionListener(al);
	   
	    /** Vytvori sa listener pre vyber urovne hry. Vyuziva sa tu aj nacitanie vsetkeho 
	     * do povodnej polohy **/
	    ActionListener alList = new ActionListener() {
	    	public void actionPerformed(ActionEvent e) {
	    		/** ziska sa uroven hry **/
	    		level = Integer.valueOf((String)list.getSelectedItem());
	    		/** prideli sa k poctu tehliciek **/
	    		pocetTeh = level;
	    		/** a tu sa spravi nieco ako restart, to znamena, ze hra vrati do zaciatocneho
	    		 * stavu **/
	    		cas = 0;
				lab.setText("Time    0");			
	            System.out.println(level);
	            repaint();
	            step = 0;
	            steps.setText("     " + String.valueOf(step) + "     ");
				end = false;				
			    int pom = 100;
				for (int i = 0; i < 3; i++) {
					stl[i].x = pom;
					stl[i].y = 300;				
					pom += 200;
				}
							
				cuc.x = stl[1].x-45;
				cuc.y = 20;
				cuc.cisloVeze = 1;
									
				pom = 405;
				int pom2 = 0;
				for (int i = 0; i < pocetTeh; i++) {				
					teh[i].x = cuc.x-25-pom2;
					teh[i].y = pom;
					teh[i].width = 150+(2*pom2);
					teh[i].cisloVeze = 1;
					pom -= 15;
					pom2 -= 10;
				}
				hc.repaint();							
	        }
	    };
	    /** Prida sa action listener pre vyber urovne **/
	    list.addActionListener(alList);
	    
	    
	    ActionListener al2 = new ActionListener() {
	    	/** tato metoda je actionListener pre radioButtony **/
	        public void actionPerformed(ActionEvent e) {
	          AbstractButton aButton = (AbstractButton) e.getSource();
	          //System.out.println("Selected: " + aButton.getText());
	          /** Ak sa hra sipkami tak sa to nastavi premennym **/
	          if (aButton.getText() == "pkami") {
	        	  myska = false;
	        	  klavesnica = true;
	          }
	          /** ak sa hra myskou tak klavesnica bude mat false a myska true **/
	          else if (aButton.getText() == "mykou") {
	        	  klavesnica = false;
	        	  myska = true;
	          }
	        }	        
	      };
	    	    
	      /** pridaju sa listenery pre radioButtony a pre list urovni hry **/
	    b3.addActionListener(al2);
	    b3.setSelected(true);
	    b4.addActionListener(al2);	
	    
	    /** nastavi sa hodnota krokov na 0 **/
	    steps.setText("     0     ");	    
	}					
			
	/** Tato metoda sa spusti po starte appletu. Vytvaraju sa tu vsetky triedy, 
	 * s ktorymi program pracuje **/
	public void start() {		
		int pom = 100;
		/** Vytvoria sa tri veze **/
		for (int i = 0; i < 3; i++) {
			stl[i] = new Stlpik(pom, 300);
			pom += 200;
		}
		/** vytvori sa cucatko, ktore sluzi na pohyb tehliciek pomocou klavesnice **/
		cuc = new Cucatko(stl[1].x-45, 20, 1);		
		
		pom = 405;
		int pom2 = 0;
		/** Vytvori sa dany pocet tehliciek, zalezi od urvone hry **/
		for (int i = 0; i < pocetTeh; i++) {
			teh[i] = new Tehlicka(cuc.x-25-pom2, pom, 150+(2*pom2), 1);
			pom -= 15;
			pom2 -= 10;
		}
				
	}
	
			
	
}
