import java.awt.*;
import java.awt.event.*;

/** Tato trieda je Canvasova trieda. Sluzi na vykreslenie vsetkeho co sa robi. Okrem toho 
 * implementeju KeyListener a MouseListener a s nimi pracuje. **/

public class Hanoj_canvas extends Canvas implements KeyListener, MouseListener, MouseMotionListener {
	/** premenna parent je pre hlavnu triedu, cize pre applet **/
	Hanoj parent;
	/** pre narast prenosnosti **/
	private static final long serialVersionUID = 2009010901L;
	/** tato premenna sluzi na zistenie kodu stlacenej klavesy **/
	public int key;
	/** tieto premmenne poc0, poc2 sa vyuzivaju na konci hry, ked niekto vyhra, do nic
	 * sa dava pocet tehliciek v danom stlpiku **/
	public int poc0, poc2;
	/** Zistuje, ci je stlacena sipka dolu. Vyuziva sa pri konci hry **/
	boolean poloz;
	
	/** Constructor triedy Hanoj_canvas. Tu sa nastavi velkost canvasu, pridaju sa listenery 
	 * a k premennym sa nastavia prislusne hodnoty. Vola sa tu h typu Hanoj vdaka ktoremu
	 * sa daju ovladat vsetky casti z appletu**/
	public Hanoj_canvas(Hanoj h) {
		parent = h;
		this.setSize(parent.sizeX, parent.sizeY);
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);		
		setVisible(true);
		setFocusable(true);		
		poloz = false;
	}
	
	/** Tato metoda sa spusti po stlaceni tlacitka. Vyuziva tu len 4 tlacitka a to su sipky.
	 * Podla toho aka sipka je stlacena, tak sa pohne cucatko s tehlickou **/
	public void keyPressed(KeyEvent e) {
		/** ziska sa hodnota stlacenej klavesy **/
		key = e.getKeyCode();
		System.out.println(key);
		/** ak je hra zacata a zaroven je radioButton nastaveny na hru klavesnicou
		 * a zaroven nie je koniec hry, tak je splnena podmienka **/
		if (parent.start && parent.klavesnica && !(parent.end)) {
			/** ak je stlacena sipka dole, tak sa premenna poloz, ktora sluzi na ukoncenie
			 * hry, nastavy na true, ak nie je tak na false**/
			if (key == 40)
				poloz = true;
			else
				poloz = false;
			
		/** podla stlacenej klavesy postupujeme dalej **/
		switch (key) {
		/** ak je to sipka vlavo, tak sa Cucatko aj s tehlickou posunu dolava.
		 * Zalezi tu potom uz len na tom, ze ci podmienky vo vnutri tried Cucatko 
		 * a Tehlicka ich dovolia presunut **/
		  case 37:		
			  /** posun Cucatka **/
			  parent.cuc.posun(-200);
			  /** posun prave tej tehlicka, ktora sa nachadza hore na vezami **/
			  for (int i = 0; i < parent.pocetTeh; i++) {
				  if (parent.teh[i].y == 36) 
					  parent.teh[i].posunStrana(-200, parent.cuc.cisloVeze);				  
			  }			  
			  break;
		  /** ak je stlacena sipka vpravo **/
		  case 39:			  
			  /** posun Cucatka **/
			  parent.cuc.posun(200);
			  /** posun prave tej tehlicka, ktora sa nachadza hore na vezami **/
			  for (int i = 0; i < parent.pocetTeh; i++) {
				  if (parent.teh[i].y == 36) 
					  parent.teh[i].posunStrana(200, parent.cuc.cisloVeze);					  				  
			  }
			  break;
		  /** ak je stlacena sipka hore **/
		  case 38:
			  /** premenna pravda sluzi na zistinie, ci je nejaka tehlicka uz hore 
			   * nad vezickami**/
			  boolean pravda = true;
			  for (int i = 0; i < parent.pocetTeh; i++) {
				  if (parent.teh[i].y == 36)
					  pravda = false;
			  }
			  /** ak ano, tak sa pomUrovne sa nastavi index tehlicky,  
			   * ktorej cislo veze sa zhoduje s cislom cucatka, ktore je prave nad 
			   * nejakou vezickou, inak -1 **/
			  if (pravda) {				  
				  parent.pomUroven = -1;
			    for (int i = 0; i < parent.pocetTeh; i++) 
				    if (parent.teh[i].cisloVeze == parent.cuc.cisloVeze)					  
				    	parent.pomUroven = i;				  
			    /** ak nie -1, tak sa prislusna tehlicka posunie smerom hore**/
			    if (parent.pomUroven != -1) 
			    	parent.teh[parent.pomUroven].SetY(36);			    
			  }
			  break;
		  /** ak je stlacena sipka dole **/
		  case 40:	
			  /** pomocna premenna, do ktorej sa da true, ak sa tehlicka nachadza hore **/
			  boolean pravda2 = false;
			  /** do tejto hodnoty sa priradi hodnota tehlicky hore, inak 0 **/
			  int ciJeMensie = 0; 
			  for (int i = 0; i < parent.pocetTeh; i++) {
				  if (parent.teh[i].y == 36) {
					  ciJeMensie = i;
					  pravda2 = true;					  
				  }
			  }			  
			  /** Ak je tehlicka hore, tak sa pre nu skontroluje ci je mensia ako
			   * kazda z tehliciek leziacich na vezicke, na ktoru chce ist **/
			  if (pravda2)
			    for (int i = 0; i < parent.pocetTeh; i++) {
				    if (parent.teh[ciJeMensie].cisloVeze == parent.teh[i].cisloVeze)
				      if (parent.teh[ciJeMensie].width > parent.teh[i].width)
					      pravda2 = false;
 			    }			  
			  /** Vyuziva sa tato premenna, sem sa nastavi false ak je tehlicka
			   * hore vacsia ako nejako dole **/
			  if (pravda2) {	
				/** zistuje ci sa cislo veze == cislu cucatka **/
			    int cislo = 0;
			    /** ak sa cislo veze rovna cislu cucatka, tak incrementuje premennu cislo **/
			    for (int i = 0; i < parent.pocetTeh; i++) {				  
				    if (parent.teh[i].y != 36)
				      if (parent.teh[i].cisloVeze == parent.cuc.cisloVeze)				    	
					      cislo++;					    				    
			    }
			    /** Ak je vsetko splnene, tak sa tehlicka presunie, inak zostane tam 
			     * kde bola **/
			    if (parent.pomUroven != -1) {			      
			      if (cislo >= 0) {			    	  
			    	  parent.teh[parent.pomUroven].SetY(405-cislo*15);
			    	  parent.step++;
			    	  parent.steps.setText("     " + String.valueOf(parent.step) + "     ");					  
			      }
			      else
			    	  parent.teh[parent.pomUroven].SetY(405);
			    }			  
			  }
		}		
		repaint();
		}
	}
	
	public void keyTyped(KeyEvent e) {
		
	}
	
	public void keyReleased(KeyEvent e) {
				
	}
	
	//**************** My ********************
	
	/** Tato metoda stlacenia mysi sluzi na zistenie, ze na ktoru tehlicku bolo kliknute, ci bolo 
	 * vobec na nejaku kliknute a ci ta tehlicka na ktoru bolo kliknute je najmensia v tom stlpiku,
	 * lebo inak sa nesmie oznacit. Najmensia znamena, ze je prva hore.**/
	public void mousePressed( MouseEvent e ) {
		/** ak je hra zacata a zaroven je radioButton nastaveny na hru myskou
		 * a zaroven nie je koniec hry, tak je splnena podmienka **/
		if (parent.start && parent.myska && !(parent.end)) {
	    /** pomocna premenna na zistenie ci je tehlicka mensia ako tehlicky na ktore
	     * ju treba ulozit **/	
		boolean pravdaMensie = false;
		/** pomocne premenne, na zistenie rozsahu kliku **/
		int pomX = 75;
		double pomY = 7.5;		
		for (int i = 0; i < parent.pocetTeh; i++) {				
			/** ak je kliknute na tehlicku, tak sa tehlicka zapamata v premennej tehI **/
			if(Math.abs(e.getX() - (parent.teh[i].x + pomX)) < pomX) {
				if(Math.abs(e.getY() - (parent.teh[i].y + pomY)) < pomY) {
					
					parent.tehI = i;
					
					/** Tu sa kontroluje ci dana tehlicka, na ktoru sa kliklo je najmensia
					 * v tom stlpiku **/
					for (int k = 0; k < 3; k++) {						
			    		if(Math.abs(e.getX() - parent.stl[k].x) < ((80 - parent.tehI*10)+1)) {
			    			pravdaMensie = true;
			    			for (int j = 0; j < parent.pocetTeh; j++) {
			    				if (parent.teh[parent.tehI].cisloVeze == parent.teh[j].cisloVeze)
			    					if (parent.teh[parent.tehI].width > parent.teh[j].width) {
			    						pravdaMensie = false;				    						
			    					}
			    			}
			    		}
					}
					/** ak je najmensia, tak je vsetko v poriadku a zalohuje sa jej x, y
					 * a povie sa, ze sa kliklo **/
					if (pravdaMensie) {					  
						  //System.out.println(teh[i].x + pomX + " " + (teh[i].y + pomY));
					  parent.klik = true;						
					  parent.oldStavX = parent.teh[parent.tehI].x;
					  parent.oldStavY = parent.teh[parent.tehI].y;
					}
				}
			}
			pomX -= 10;				
			//System.out.println(teh[i].x + " " + teh[i].y);				
		}
		}
	}

	/** Ak je splnena podmienka stlacenia mysi, tak tato metoda dovoli zvolenej tehlicke sa umiestnit
	 * na stlpiku, na ktory sme prisli, ale len vtedy ak je tato aktualna tehlicka mensia ako vsetky
	 * tehlicky daneho stlpika. Ak nie je, tak ju vrati tam skade sme ju zobrali**/
    public void mouseReleased( MouseEvent e ) {    	
    	/** ak je hra zacata a zaroven je radioButton nastaveny na hru myskou
		 * a zaroven nie je koniec hry, tak je splnena podmienka **/
    	if (parent.start && parent.myska && !(parent.end)) {
    	/** Ak sa kliklo tak mozeme pokracovat **/
    	if (parent.klik) {	    	
    	boolean pravdaMensie = false;
    	parent.klik = false;
    	int cislo = 0;
    	boolean pom = false;
    	int pomCisloVeze = parent.teh[parent.tehI].cisloVeze; 
    	for (int i = 0; i < 3; i++) {
    		/** Zistuje sa ci je dana tehlicka najmensia **/
    		if(Math.abs(e.getX() - parent.stl[i].x) < ((80 - parent.tehI*10)+1)) {
    			parent.teh[parent.tehI].cisloVeze = i;
    			pravdaMensie = true;
    			for (int j = 0; j < parent.pocetTeh; j++) {
    				if (parent.teh[parent.tehI].cisloVeze == parent.teh[j].cisloVeze)
    					if (parent.teh[parent.tehI].width > parent.teh[j].width) {    						
    						pravdaMensie = false;				    						
    					}
    			}
    			parent.teh[parent.tehI].cisloVeze = pomCisloVeze;
    			/** ak je najmensia dana tehlicka, tak sa presunie **/
    			if (pravdaMensie) {
    				/** nastavi sa krok o jeden naviac **/
    			  parent.step++;
    			  parent.steps.setText("     " + String.valueOf(parent.step) + "     ");
    			  /** tato premenna sluzi na povedanie, ze je dobre **/
	    		  pom = true;
	    		  parent.teh[parent.tehI].x = parent.stl[i].x - (70 - parent.tehI*10);		    		  
	    		  //teh[tehI].y = 410 - 5;
	    		  parent.teh[parent.tehI].cisloVeze = i;
	    		  for (int z = 0; z < parent.pocetTeh; z++) {
	    			  if (parent.teh[z].cisloVeze == parent.teh[parent.tehI].cisloVeze)				    	
	    				  cislo++;
	    		  }		    		  		    		  
	    		  parent.teh[parent.tehI].SetY(420-cislo*15);
	    		  //teh[tehI].cisloVeze = i;
	    		  repaint();
    			}	    				    				
    		}	    	  
    	}
    	/** Ak nie je dobre, tak sa tehlicka vrati naspat **/
    	if (pom == false) {    		
    		parent.teh[parent.tehI].x = parent.oldStavX;
    		parent.teh[parent.tehI].y = parent.oldStavY;
    		    		
    		repaint();
    	}	    	
    	}
    	}
    }
    
    public void mouseExited( MouseEvent e ) {}
    public void mouseEntered( MouseEvent e ) {}
    public void mouseClicked( MouseEvent e ) {}
    
    /** Ak je splnena podmienka stlacenia mysi, tak tato metoda dovoli presuvat tehlicku po ploche. **/
    public void mouseDragged(MouseEvent e) {
    	/** ak je hra zacata a zaroven je radioButton nastaveny na hru myskou
		 * a zaroven nie je koniec hry, tak je splnena podmienka **/
    	if (parent.start && parent.myska && !(parent.end)) {
    		/** ak je klinute, tak sa tehlicka presuva, animuje po ploche **/
    	if (parent.klik) {
    		//System.out.print(e.getX() + " " + e.getY() + " .. ");	    		
    		parent.teh[parent.tehI].x = Math.abs(e.getX()) - (70 - parent.tehI*10);	    		
    		parent.teh[parent.tehI].y = Math.abs(e.getY()) - 5;
    		
    		    	
    		repaint();	    	
    	}
    	}
    }
    
    public void mouseMoved(MouseEvent e) {}
	
    /** Tato metoda sluzi na vykreslenie vsetkeho co je v canvase. Je to jedna z casti, 
     * vdaka ktorej vieme zabezpecit neblikanie obrazovky.  **/
	public void update(Graphics g) {					
		g.drawImage( parent.backbuffer, 0, 0, parent.sizeX-2, parent.sizeY-2, this );
		/** Vykresli sa pozadie **/
	    parent.backg.drawImage( parent.Background, 0, 0, this );	    
		//g.drawImage( parent.Background, 0, 0, parent.sizeX-2, parent.sizeY-2, this );
		
	    /** vykreslia sa vezicky **/
		for (int i = 0; i < 3; i++) {						
			parent.backg.drawImage(parent.ObrStlpik, parent.stl[i].x, 120, 10, parent.stl[i].y, this);
		}		
		/** vykresli sa cucatko **/
		parent.backg.drawImage(parent.ObrCucatko, parent.cuc.x-10, parent.cuc.y, 100, 53, this);
				
		/** pomocne premenne, sluzia ako pocitadlo kolko tehliciek je presunutych **/
		poc0 = 0;
		poc2 = 0;
		for (int i = 0; i < parent.pocetTeh; i++) {			
			/** vykreslia sa tehlicky **/
			parent.backg.drawImage(parent.ObrTehlicka, parent.teh[i].x, parent.teh[i].y, parent.teh[i].width, 15, this);
			if (parent.teh[i].cisloVeze == 0) {
				poc0++;
			}else if (parent.teh[i].cisloVeze == 2) {
				poc2++;
			}
			
		}
		/** ak je polozena posledna tehlicka, tak je koniec hry a vykresli sa obrazok
		 * HURA **/
		if (poloz) {
		if (poc0 == parent.pocetTeh || poc2 == parent.pocetTeh) {
			parent.backg.drawImage( parent.Hura, parent.stl[1].x-126, 20, this );
			parent.end = true;			
			parent.go = false;
		}
		}
		
		//repaint();
		g.drawImage( parent.backbuffer, 0, 0, parent.sizeX-2, parent.sizeY-2, this );		
	}
	
	/** Tato metoda sluzi na spustenie metody update **/
    public void paint( Graphics g ) {    	
    	update( g );    	
    }
}
